#ifndef _KGR_PATCH_ENTRY_CODE_H
#define _KGR_PATCH_ENTRY_CODE_H

#ifdef __ASSEMBLY__

.macro KGR_CALL_RELOCS_BEGIN
.pushsection .init.rodata, 524950, "a"
.global kgr_call_relocs_begin
.align 8
kgr_call_relocs_begin:
.popsection
.endm

.macro KGR_CALL_RELOCS_END
.global kgr_call_relocs_end
.pushsection .init.rodata, 524950, "a"
kgr_call_relocs_end:
.popsection
.endm

.macro KGR_CALL_PATCH fun
.byte 0xe8 /* opcode */
524950:
.int 0xdecafbad
.pushsection .init.rodata, 524950, "a"
	.quad 524950b
	.quad \fun
.popsection
.endm

.macro KGR_JMP_PATCH fun
.byte 0xe9 /* opcode */
524950:
.int 0xdecafbad
.pushsection .init.rodata, 524950, "a"
	.quad 524950b
	.quad \fun
.popsection
.endm

#else /* !__ASSEMBLY__ */

int kgr_patch_entry_code_init(void);

extern char __kgr_entry_text_begin[];
extern char __kgr_entry_text_end[];

#define kgr_entry_text_begin ((unsigned long)__kgr_entry_text_begin)
#define kgr_entry_text_end ((unsigned long)__kgr_entry_text_end)


#endif /* __ASSEMBLY__ */

#endif /* _KGR_PATCH_ENTRY_CODE_H */
